<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from cookbook.texi on 28 April 1999 -->

<TITLE>The SUIF COOKBOOK - Example 1</TITLE>
<link href="cookbook_3.html" rel=Next>
<link href="cookbook_1.html" rel=Previous>
<link href="cookbook_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_1.html">previous</A>, <A HREF="cookbook_3.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
<P><HR><P>


<H1><A NAME="SEC2" HREF="cookbook_toc.html#TOC2">Example 1 - Print Procedure Names</A></H1>

<P>
This program is a SUIF pass that will print the procedure names of
all the procedures in the input program.

</P>


<H2><A NAME="SEC3" HREF="cookbook_toc.html#TOC3">prog1.cc</A></H2>

<PRE>
#include &#60;stdlib.h&#62;
#include &#60;suif1.h&#62;

void do_proc(tree_proc * tp)
{
    proc_sym * psym = tp-&#62;proc();
    printf("%s \n", psym-&#62;name());
}

main(int argc, char * argv[])
{
    start_suif(argc, argv);
    suif_proc_iter(argc, argv, do_proc);
}
</PRE>

<P>
<A NAME="IDX1"></A>
<A NAME="IDX2"></A>
<A NAME="IDX3"></A>
<A NAME="IDX4"></A>
<A NAME="IDX5"></A>
<A NAME="IDX6"></A>
<A NAME="IDX7"></A>
<A NAME="IDX8"></A>
<A NAME="IDX9"></A>

</P>


<H2><A NAME="SEC4" HREF="cookbook_toc.html#TOC4">Makefile</A></H2>

<PRE>
TARGET = prog1
LIBS =		-lsuif1
SRCS =		prog1.cc
OBJS =		prog1.o

all:		prog1
install-bin:	install-prog

include $(SUIFHOME)/Makefile.std
</PRE>

<P>
<A NAME="IDX10"></A>
<A NAME="IDX11"></A>

</P>


<H2><A NAME="SEC5" HREF="cookbook_toc.html#TOC5">Compiling the program</A></H2>

<PRE>
csh&#62; gmake
g++ -c -g -Wall  -I/suif/suif/suifhome/include   prog1.cc
g++ -o prog1 -g -Wall  -I/suif/suif/suifhome/include   prog1.o suif_init.o \
                 -L/suif/suif/suifhome/mips-dec-ultrix/lib  -lsuif1 prog_ver.cc
csh&#62;
</PRE>

<P>
<A NAME="IDX12"></A>

</P>


<H2><A NAME="SEC6" HREF="cookbook_toc.html#TOC6">Testing the pass</A></H2>
<P>
Let's use the following input file:

</P>


<H3><A NAME="SEC7" HREF="cookbook_toc.html#TOC7">input1.c</A></H3>

<PRE>
test1() {  }
test_program() {  }
foo() {  }
bar() {  }
</PRE>



<H3><A NAME="SEC8" HREF="cookbook_toc.html#TOC8">Test session</A></H3>

<PRE>
csh&#62; scc -V -.spd input1.c
CPP: /suif/suif/suifhome/mips-dec-ultrix/bin/cpp -D__SCC__ -D__LANGUAGE_C -D__unix 
-D__host_m ips -D__mips -D__MIPSEL   -I/suif/suif/suifhome/mips-dec-ultrix/include 
-nostdinc -I/usr/include input1.c /tmp/scc09665_0.i
SNOOT: /suif/suif/suifhome/mips-dec-ultrix/bin/snoot   /tmp/scc09665_0.i 
/tmp/scc09665_1.snt
PORKY_DEFAULTS: /suif/suif/suifhome/mips-dec-ultrix/bin/porky -defaults  
/tmp/scc09665_1.snt input1.spd
csh&#62; prog1 input1.spd
test1
test_program
foo
bar
csh&#62;
</PRE>

<P>
<A NAME="IDX13"></A>
<A NAME="IDX14"></A>
<A NAME="IDX15"></A>
<A NAME="IDX16"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="cookbook_1.html">first</A>, <A HREF="cookbook_1.html">previous</A>, <A HREF="cookbook_3.html">next</A>, <A HREF="cookbook_8.html">last</A> section, <A HREF="cookbook_toc.html">table of contents</A>.
</BODY>
</HTML>
